Loading...
Searching...
No Matches
BALL::HINFile Class Reference
Molecular Modeling » File Formats » Molecular structure file formats

`#include <BALL/FORMAT/HINFile.h>`

Inheritance diagram for BALL::HINFile:

## Public Member Functions

Constructors and Destructors
| HINFile ()
| HINFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~HINFile ()
Assignment.
const HINFile & | operator= (const HINFile &rhs)
Reading and Writing of Kernel Datastructures
virtual bool | write (const Molecule &molecule)
virtual bool | write (const System &system)
virtual Molecule * | read ()
virtual bool | read (System &system)
Public Member Functions inherited from BALL::GenericMolFile
| GenericMolFile ()
| GenericMolFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~GenericMolFile ()
virtual void | close ()
const GenericMolFile & | operator= (const GenericMolFile &rhs)
void | defineInputAsTemporary (bool b=true)
void | enableOutputCompression (String zipped_filename)
bool | isCompressedFile ()
virtual GenericMolFile & | operator>> (System &system)
virtual GenericMolFile & | operator<< (const System &system)
virtual GenericMolFile & | operator>> (Molecule &molecule)
virtual GenericMolFile & | operator<< (const Molecule &molecule)
Public Member Functions inherited from BALL::LineBasedFile
| LineBasedFile ()
| Default constructor.
| LineBasedFile (const String &filename, File::OpenMode open_mode=std::ios::in, bool trim_whitespaces=false)
void | clear ()
bool | operator== (const LineBasedFile &f)
bool | operator!= (const LineBasedFile &f)
const LineBasedFile & | operator= (const LineBasedFile &file)
Position | getLineNumber () const
| Get the last line number in the file.
const String & | getLine () const
| Return the current line.
String & | getLine ()
| Return the current line.
bool | readLine ()
bool | skipLines (Size number=1)
bool | search (const String &text, bool return_to_start=false)
bool | search (const String &text, const String &stop, bool return_to_start=false)
bool | gotoLine (Position line_number)
void | rewind ()
void | test (const char *file, int line, bool condition, const String &msg) const
String | getField (Index pos=0, const String &quotes="", const String &delimiters=String::CHARACTER_CLASS__WHITESPACE) const
bool | startsWith (const String &text) const
| Test if the current line starts with text.
bool | has (const String &text) const
| Return true if the current line contains text.
Index | switchString (const std::vector< String > &data) const
bool | parseColumnFormat (const char *format, Position index, Size length, void *arg)
void | enableTrimWhitespaces (bool state)
| Set wheter leading and trailing whitespaces in lines shall be removed.
bool | trimWhiteSpacesEnabled () const
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Accessors

SimpleBox3 | box_
float | temperature_
bool | hasPeriodicBoundary () const
SimpleBox3 | getPeriodicBoundary () const
float | getTemperature () const
virtual void | initRead_ ()
| Initialize temperature and box dimensions prior to reading a system.
void | writeAtom_ (const Atom &atom, Size number, Size atom_offset)

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
virtual void | initWrite_ ()
bool | input_is_temporary_
bool | compress_output_
bool | gmf_is_closed_
String | zipped_filename_
String | line_
| buffer for the line in use
Position | line_number_
| line number in the file
bool | trim_whitespaces_
vector< char > | col_buffer_
| buffer for column parsing
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

HyperChem file class. This class enables BALL to read and write HyperChem HIN files.

Note: HIN defines a Molecule as a connected component in the molecule graph If you read e.g. a protein from a PDBFile, such that no bonds are set each atom will be placed into its own molecule. To prevent this from happening use the FragmentDB to build missing bonds.

Definition at line 29 of file HINFile.h.

## Constructor & Destructor Documentation

## HINFile() [1/2]

BALL::HINFile::HINFile | ( |  | ) |

Default constructor

## HINFile() [2/2]

BALL::HINFile::HINFile | ( | const String & | filename,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constructor

Exceptions

  Exception::FileNotFound | if the file could not be opened

## ~HINFile()

virtual BALL::HINFile::~HINFile | ( |  | ) |

virtual

Destructor

## Member Function Documentation

## getPeriodicBoundary()

SimpleBox3 BALL::HINFile::getPeriodicBoundary | ( |  | ) | const

Return the periodic boundary of the file. An empty box is returned if no periodic boundary is defined.

Returns
  the boundary box

## getTemperature()

float BALL::HINFile::getTemperature | ( |  | ) | const

Return the temperature stored in the file. HIN files may contain a sys entry containing the temperature of the last simulation step. If it is set, it is returned. Otherwise 0 is returned.

Returns
  the final simulation temperature

## hasPeriodicBoundary()

bool BALL::HINFile::hasPeriodicBoundary | ( |  | ) | const

Check for a periodic boundary in the file.

## initRead_()

virtual void BALL::HINFile::initRead_ | ( |  | ) |

protected virtual

Initialize temperature and box dimensions prior to reading a system.

Reimplemented from BALL::GenericMolFile.

## operator=()

const HINFile & BALL::HINFile::operator= | ( | const HINFile & | rhs | ) |

Assignment operator.

Exceptions

  Exception::FileNotFound | if the file could not be opened

## read() [1/2]

virtual Molecule * BALL::HINFile::read | ( |  | ) |

virtual

Read a molecule from the HIN file

Exceptions

  Exception::ParseError | if a syntax error was encountered

Reimplemented from BALL::GenericMolFile.

## read() [2/2]

virtual bool BALL::HINFile::read | ( | System & | system | ) |

virtual

Reimplemented from BALL::GenericMolFile.

## write() [1/2]

virtual bool BALL::HINFile::write | ( | const Molecule & | molecule | ) |

virtual

Write a molecule to a HIN file. Note that this changes the properties of atoms in the system.

Exceptions

  File::CannotWrite | if writing to the file failed

Reimplemented from BALL::GenericMolFile.

## write() [2/2]

virtual bool BALL::HINFile::write | ( | const System & | system | ) |

virtual

Write a system to a HIN file. Note that this changes the properties of atoms in the system.

Exceptions

  File::CannotWrite | if writing to the file failed

Reimplemented from BALL::GenericMolFile.

## writeAtom_()

void BALL::HINFile::writeAtom_ | ( | const Atom & | atom,
|  | Size | number,
|  | Size | atom_offset )

protected

## Member Data Documentation

## box_

SimpleBox3 BALL::HINFile::box_

protected

Definition at line 114 of file HINFile.h.

## temperature_

float BALL::HINFile::temperature_

protected

Definition at line 119 of file HINFile.h.